library IEEE;
use IEEE.std_logic_1164.all;
use work.conv_pkg.all;

-- Generated from Simulink block "edgePenh/5x5Filter1/ABS1"

entity abs1_entity_ba1e9f5ee5 is
  port (
    ce_5: in std_logic;
    clk_5: in std_logic;
    in1: in std_logic_vector(12 downto 0);
    out1: out std_logic_vector(13 downto 0)
  );
end abs1_entity_ba1e9f5ee5;

architecture structural of abs1_entity_ba1e9f5ee5 is
  signal addsub15_s_net_x0: std_logic_vector(12 downto 0);
  signal ce_5_sg_x0: std_logic;
  signal clk_5_sg_x0: std_logic;
  signal mux_y_net_x0: std_logic_vector(13 downto 0);
  signal negate_op_net: std_logic_vector(13 downto 0);
  signal register1_q_net: std_logic_vector(12 downto 0);
  signal register2_q_net: std_logic;
  signal slice_y_net: std_logic;

begin
  ce_5_sg_x0 <= ce_5;
  clk_5_sg_x0 <= clk_5;
  addsub15_s_net_x0 <= in1;
  out1 <= mux_y_net_x0;

  mux: entity work.mux_ebc95f071a
    port map (
      ce => ce_5_sg_x0,
      clk => clk_5_sg_x0,
      clr => '0',
      d0 => register1_q_net,
      d1 => negate_op_net,
      sel(0) => register2_q_net,
      y => mux_y_net_x0
    );

  negate: entity work.negate_938915fa7e
    port map (
      ce => ce_5_sg_x0,
      clk => clk_5_sg_x0,
      clr => '0',
      ip => addsub15_s_net_x0,
      op => negate_op_net
    );

  register1: entity work.xlregister
    generic map (
      d_width => 13,
      init_value => b"0000000000000"
    )
    port map (
      ce => ce_5_sg_x0,
      clk => clk_5_sg_x0,
      d => addsub15_s_net_x0,
      en => "1",
      rst => "0",
      q => register1_q_net
    );

  register2: entity work.xlregister
    generic map (
      d_width => 1,
      init_value => b"0"
    )
    port map (
      ce => ce_5_sg_x0,
      clk => clk_5_sg_x0,
      d(0) => slice_y_net,
      en => "1",
      rst => "0",
      q(0) => register2_q_net
    );

  slice: entity work.xlslice
    generic map (
      new_lsb => 12,
      new_msb => 12,
      x_width => 13,
      y_width => 1
    )
    port map (
      x => addsub15_s_net_x0,
      y(0) => slice_y_net
    );

end structural;
library IEEE;
use IEEE.std_logic_1164.all;
use work.conv_pkg.all;

-- Generated from Simulink block "edgePenh/5x5Filter1/n-tap MAC FIR Filter/MAC Engine"

entity mac_engine_entity_f5ec5ab843 is
  port (
    a: in std_logic_vector(7 downto 0);
    b: in std_logic_vector(5 downto 0);
    ce_1: in std_logic;
    clk_1: in std_logic;
    rst: in std_logic;
    q: out std_logic_vector(8 downto 0)
  );
end mac_engine_entity_f5ec5ab843;

architecture structural of mac_engine_entity_f5ec5ab843 is
  signal accumulator_q_net_x0: std_logic_vector(8 downto 0);
  signal ce_1_sg_x0: std_logic;
  signal clk_1_sg_x0: std_logic;
  signal mult_p_net: std_logic_vector(8 downto 0);
  signal r0_q_net_x0: std_logic_vector(7 downto 0);
  signal r1_q_net_x0: std_logic_vector(5 downto 0);
  signal r2_q_net_x0: std_logic;

begin
  r0_q_net_x0 <= a;
  r1_q_net_x0 <= b;
  ce_1_sg_x0 <= ce_1;
  clk_1_sg_x0 <= clk_1;
  r2_q_net_x0 <= rst;
  q <= accumulator_q_net_x0;

  accumulator: entity work.accumulator_620e80e3aa
    port map (
      b => mult_p_net,
      ce => ce_1_sg_x0,
      clk => clk_1_sg_x0,
      clr => '0',
      rst(0) => r2_q_net_x0,
      q => accumulator_q_net_x0
    );

  mult: entity work.xlmult_v9_0
    generic map (
      a_arith => xlUnsigned,
      a_bin_pt => 0,
      a_width => 8,
      b_arith => xlSigned,
      b_bin_pt => 0,
      b_width => 6,
      c_a_type => 1,
      c_a_width => 8,
      c_b_type => 0,
      c_b_width => 6,
      c_baat => 8,
      c_output_width => 14,
      c_type => 0,
      core_name0 => "multiplier_virtex2p_10_0_102eaf484ea01e39",
      extra_registers => 0,
      multsign => 2,
      overflow => 1,
      p_arith => xlSigned,
      p_bin_pt => 0,
      p_width => 9,
      quantization => 1
    )
    port map (
      a => r0_q_net_x0,
      b => r1_q_net_x0,
      ce => ce_1_sg_x0,
      clk => clk_1_sg_x0,
      clr => '0',
      core_ce => ce_1_sg_x0,
      core_clk => clk_1_sg_x0,
      core_clr => '1',
      en => "1",
      rst => "0",
      p => mult_p_net
    );

end structural;
library IEEE;
use IEEE.std_logic_1164.all;
use work.conv_pkg.all;

-- Generated from Simulink block "edgePenh/5x5Filter1/n-tap MAC FIR Filter"

entity n_tap_mac_fir_filter_entity_bc7b8b822c is
  port (
    ce_1: in std_logic;
    ce_5: in std_logic;
    clk_1: in std_logic;
    clk_5: in std_logic;
    din: in std_logic_vector(7 downto 0);
    dout: out std_logic_vector(8 downto 0)
  );
end n_tap_mac_fir_filter_entity_bc7b8b822c;

architecture structural of n_tap_mac_fir_filter_entity_bc7b8b822c is
  signal accumulator_q_net_x0: std_logic_vector(8 downto 0);
  signal asr_q_net: std_logic_vector(7 downto 0);
  signal capture_register_q_net: std_logic_vector(8 downto 0);
  signal ce_1_sg_x1: std_logic;
  signal ce_5_sg_x1: std_logic;
  signal clk_1_sg_x1: std_logic;
  signal clk_5_sg_x1: std_logic;
  signal coefficient_rom_data_net: std_logic_vector(5 downto 0);
  signal constant_0_op_net: std_logic;
  signal counter_op_net: std_logic_vector(2 downto 0);
  signal down_sample1_q_net_x0: std_logic_vector(8 downto 0);
  signal r0_q_net_x0: std_logic_vector(7 downto 0);
  signal r1_q_net_x0: std_logic_vector(5 downto 0);
  signal r2_q_net_x0: std_logic;
  signal r3_q_net: std_logic_vector(7 downto 0);
  signal relational1_op_net: std_logic;
  signal single_port_ram_data_out_net_x0: std_logic_vector(7 downto 0);

begin
  ce_1_sg_x1 <= ce_1;
  ce_5_sg_x1 <= ce_5;
  clk_1_sg_x1 <= clk_1;
  clk_5_sg_x1 <= clk_5;
  single_port_ram_data_out_net_x0 <= din;
  dout <= down_sample1_q_net_x0;

  asr: entity work.xladdrsr
    generic map (
      addr_arith => xlUnsigned,
      addr_bin_pt => 0,
      addr_width => 3,
      core_addr_width => 3,
      core_name0 => "asr_70_v2p_f089efcdbda572f6",
      d_arith => xlUnsigned,
      d_bin_pt => 0,
      d_width => 8,
      q_arith => xlUnsigned,
      q_bin_pt => 0,
      q_width => 8
    )
    port map (
      addr => counter_op_net,
      ce => ce_5_sg_x1,
      clk => clk_5_sg_x1,
      clr => '0',
      d => r3_q_net,
      en => "1",
      q => asr_q_net
    );

  capture_register: entity work.xlregister
    generic map (
      d_width => 9,
      init_value => b"000000000"
    )
    port map (
      ce => ce_1_sg_x1,
      clk => clk_1_sg_x1,
      d => accumulator_q_net_x0,
      en(0) => r2_q_net_x0,
      rst => "0",
      q => capture_register_q_net
    );

  coefficient_rom: entity work.xlsprom
    generic map (
      c_address_width => 3,
      c_width => 6,
      core_name0 => "single_port_block_memory_virtex2p_6_1_7d992e82f841c975",
      latency => 1
    )
    port map (
      addr => counter_op_net,
      ce => ce_1_sg_x1,
      clk => clk_1_sg_x1,
      en => "1",
      rst => "0",
      data => coefficient_rom_data_net
    );

  constant_0: entity work.constant_0_4750a0be1f
    port map (
      ce => '0',
      clk => '0',
      clr => '0',
      op(0) => constant_0_op_net
    );

  counter: entity work.xlcounter_limit
    generic map (
      cnt_15_0 => 4,
      cnt_31_16 => 0,
      cnt_47_32 => 0,
      cnt_63_48 => 0,
      core_name0 => "binary_counter_virtex2p_7_0_2678e693f726e29c",
      count_limited => 1,
      op_arith => xlUnsigned,
      op_width => 3
    )
    port map (
      ce => ce_1_sg_x1,
      clk => clk_1_sg_x1,
      clr => '0',
      en => "1",
      rst => "0",
      op => counter_op_net
    );

  down_sample1: entity work.xldsamp
    generic map (
      d_arith => xlSigned,
      d_bin_pt => 0,
      d_width => 9,
      ds_ratio => 5,
      latency => 1,
      phase => 4,
      q_arith => xlSigned,
      q_bin_pt => 0,
      q_width => 9
    )
    port map (
      d => capture_register_q_net,
      dest_ce => ce_5_sg_x1,
      dest_clk => clk_5_sg_x1,
      dest_clr => '0',
      en => "1",
      src_ce => ce_1_sg_x1,
      src_clk => clk_1_sg_x1,
      src_clr => '0',
      q => down_sample1_q_net_x0
    );

  mac_engine_f5ec5ab843: entity work.mac_engine_entity_f5ec5ab843
    port map (
      a => r0_q_net_x0,
      b => r1_q_net_x0,
      ce_1 => ce_1_sg_x1,
      clk_1 => clk_1_sg_x1,
      rst => r2_q_net_x0,
      q => accumulator_q_net_x0
    );

  r0: entity work.xldelay
    generic map (
      latency => 2,
      reg_retiming => 0,
      width => 8
    )
    port map (
      ce => ce_1_sg_x1,
      clk => clk_1_sg_x1,
      d => asr_q_net,
      en => '1',
      q => r0_q_net_x0
    );

  r1: entity work.xldelay
    generic map (
      latency => 1,
      reg_retiming => 0,
      width => 6
    )
    port map (
      ce => ce_1_sg_x1,
      clk => clk_1_sg_x1,
      d => coefficient_rom_data_net,
      en => '1',
      q => r1_q_net_x0
    );

  r2: entity work.xldelay
    generic map (
      latency => 1,
      reg_retiming => 0,
      width => 1
    )
    port map (
      ce => ce_1_sg_x1,
      clk => clk_1_sg_x1,
      d(0) => relational1_op_net,
      en => '1',
      q(0) => r2_q_net_x0
    );

  r3: entity work.xldelay
    generic map (
      latency => 1,
      reg_retiming => 0,
      width => 8
    )
    port map (
      ce => ce_5_sg_x1,
      clk => clk_5_sg_x1,
      d => single_port_ram_data_out_net_x0,
      en => '1',
      q => r3_q_net
    );

  relational1: entity work.relational1_4c0cd11c3f
    port map (
      a => counter_op_net,
      b(0) => constant_0_op_net,
      ce => ce_1_sg_x1,
      clk => clk_1_sg_x1,
      clr => '0',
      op(0) => relational1_op_net
    );

end structural;
library IEEE;
use IEEE.std_logic_1164.all;
use work.conv_pkg.all;

-- Generated from Simulink block "edgePenh/5x5Filter1/n-tap MAC FIR Filter1/MAC Engine"

entity mac_engine_entity_0cc7268f36 is
  port (
    a: in std_logic_vector(7 downto 0);
    b: in std_logic_vector(5 downto 0);
    ce_1: in std_logic;
    clk_1: in std_logic;
    rst: in std_logic;
    q: out std_logic_vector(9 downto 0)
  );
end mac_engine_entity_0cc7268f36;

architecture structural of mac_engine_entity_0cc7268f36 is
  signal accumulator_q_net_x0: std_logic_vector(9 downto 0);
  signal ce_1_sg_x2: std_logic;
  signal clk_1_sg_x2: std_logic;
  signal mult_p_net: std_logic_vector(8 downto 0);
  signal r0_q_net_x0: std_logic_vector(7 downto 0);
  signal r1_q_net_x0: std_logic_vector(5 downto 0);
  signal r2_q_net_x0: std_logic;

begin
  r0_q_net_x0 <= a;
  r1_q_net_x0 <= b;
  ce_1_sg_x2 <= ce_1;
  clk_1_sg_x2 <= clk_1;
  r2_q_net_x0 <= rst;
  q <= accumulator_q_net_x0;

  accumulator: entity work.accumulator_2f069492a5
    port map (
      b => mult_p_net,
      ce => ce_1_sg_x2,
      clk => clk_1_sg_x2,
      clr => '0',
      rst(0) => r2_q_net_x0,
      q => accumulator_q_net_x0
    );

  mult: entity work.xlmult_v9_0
    generic map (
      a_arith => xlUnsigned,
      a_bin_pt => 0,
      a_width => 8,
      b_arith => xlSigned,
      b_bin_pt => 0,
      b_width => 6,
      c_a_type => 1,
      c_a_width => 8,
      c_b_type => 0,
      c_b_width => 6,
      c_baat => 8,
      c_output_width => 14,
      c_type => 0,
      core_name0 => "multiplier_virtex2p_10_0_102eaf484ea01e39",
      extra_registers => 0,
      multsign => 2,
      overflow => 1,
      p_arith => xlSigned,
      p_bin_pt => 0,
      p_width => 9,
      quantization => 1
    )
    port map (
      a => r0_q_net_x0,
      b => r1_q_net_x0,
      ce => ce_1_sg_x2,
      clk => clk_1_sg_x2,
      clr => '0',
      core_ce => ce_1_sg_x2,
      core_clk => clk_1_sg_x2,
      core_clr => '1',
      en => "1",
      rst => "0",
      p => mult_p_net
    );

end structural;
library IEEE;
use IEEE.std_logic_1164.all;
use work.conv_pkg.all;

-- Generated from Simulink block "edgePenh/5x5Filter1/n-tap MAC FIR Filter1"

entity n_tap_mac_fir_filter1_entity_98437ef112 is
  port (
    ce_1: in std_logic;
    ce_5: in std_logic;
    clk_1: in std_logic;
    clk_5: in std_logic;
    din: in std_logic_vector(7 downto 0);
    dout: out std_logic_vector(9 downto 0)
  );
end n_tap_mac_fir_filter1_entity_98437ef112;

architecture structural of n_tap_mac_fir_filter1_entity_98437ef112 is
  signal accumulator_q_net_x0: std_logic_vector(9 downto 0);
  signal asr_q_net: std_logic_vector(7 downto 0);
  signal capture_register_q_net: std_logic_vector(9 downto 0);
  signal ce_1_sg_x3: std_logic;
  signal ce_5_sg_x2: std_logic;
  signal clk_1_sg_x3: std_logic;
  signal clk_5_sg_x2: std_logic;
  signal coefficient_rom_data_net: std_logic_vector(5 downto 0);
  signal constant_0_op_net: std_logic;
  signal counter_op_net: std_logic_vector(2 downto 0);
  signal down_sample1_q_net_x0: std_logic_vector(9 downto 0);
  signal r0_q_net_x0: std_logic_vector(7 downto 0);
  signal r1_q_net_x0: std_logic_vector(5 downto 0);
  signal r2_q_net_x0: std_logic;
  signal r3_q_net: std_logic_vector(7 downto 0);
  signal relational1_op_net: std_logic;
  signal single_port_ram_data_out_net_x0: std_logic_vector(7 downto 0);

begin
  ce_1_sg_x3 <= ce_1;
  ce_5_sg_x2 <= ce_5;
  clk_1_sg_x3 <= clk_1;
  clk_5_sg_x2 <= clk_5;
  single_port_ram_data_out_net_x0 <= din;
  dout <= down_sample1_q_net_x0;

  asr: entity work.xladdrsr
    generic map (
      addr_arith => xlUnsigned,
      addr_bin_pt => 0,
      addr_width => 3,
      core_addr_width => 3,
      core_name0 => "asr_70_v2p_f089efcdbda572f6",
      d_arith => xlUnsigned,
      d_bin_pt => 0,
      d_width => 8,
      q_arith => xlUnsigned,
      q_bin_pt => 0,
      q_width => 8
    )
    port map (
      addr => counter_op_net,
      ce => ce_5_sg_x2,
      clk => clk_5_sg_x2,
      clr => '0',
      d => r3_q_net,
      en => "1",
      q => asr_q_net
    );

  capture_register: entity work.xlregister
    generic map (
      d_width => 10,
      init_value => b"0000000000"
    )
    port map (
      ce => ce_1_sg_x3,
      clk => clk_1_sg_x3,
      d => accumulator_q_net_x0,
      en(0) => r2_q_net_x0,
      rst => "0",
      q => capture_register_q_net
    );

  coefficient_rom: entity work.xlsprom
    generic map (
      c_address_width => 3,
      c_width => 6,
      core_name0 => "single_port_block_memory_virtex2p_6_1_837199ed636893a6",
      latency => 1
    )
    port map (
      addr => counter_op_net,
      ce => ce_1_sg_x3,
      clk => clk_1_sg_x3,
      en => "1",
      rst => "0",
      data => coefficient_rom_data_net
    );

  constant_0: entity work.constant_0_4750a0be1f
    port map (
      ce => '0',
      clk => '0',
      clr => '0',
      op(0) => constant_0_op_net
    );

  counter: entity work.xlcounter_limit
    generic map (
      cnt_15_0 => 4,
      cnt_31_16 => 0,
      cnt_47_32 => 0,
      cnt_63_48 => 0,
      core_name0 => "binary_counter_virtex2p_7_0_2678e693f726e29c",
      count_limited => 1,
      op_arith => xlUnsigned,
      op_width => 3
    )
    port map (
      ce => ce_1_sg_x3,
      clk => clk_1_sg_x3,
      clr => '0',
      en => "1",
      rst => "0",
      op => counter_op_net
    );

  down_sample1: entity work.xldsamp
    generic map (
      d_arith => xlSigned,
      d_bin_pt => 0,
      d_width => 10,
      ds_ratio => 5,
      latency => 1,
      phase => 4,
      q_arith => xlSigned,
      q_bin_pt => 0,
      q_width => 10
    )
    port map (
      d => capture_register_q_net,
      dest_ce => ce_5_sg_x2,
      dest_clk => clk_5_sg_x2,
      dest_clr => '0',
      en => "1",
      src_ce => ce_1_sg_x3,
      src_clk => clk_1_sg_x3,
      src_clr => '0',
      q => down_sample1_q_net_x0
    );

  mac_engine_0cc7268f36: entity work.mac_engine_entity_0cc7268f36
    port map (
      a => r0_q_net_x0,
      b => r1_q_net_x0,
      ce_1 => ce_1_sg_x3,
      clk_1 => clk_1_sg_x3,
      rst => r2_q_net_x0,
      q => accumulator_q_net_x0
    );

  r0: entity work.xldelay
    generic map (
      latency => 2,
      reg_retiming => 0,
      width => 8
    )
    port map (
      ce => ce_1_sg_x3,
      clk => clk_1_sg_x3,
      d => asr_q_net,
      en => '1',
      q => r0_q_net_x0
    );

  r1: entity work.xldelay
    generic map (
      latency => 1,
      reg_retiming => 0,
      width => 6
    )
    port map (
      ce => ce_1_sg_x3,
      clk => clk_1_sg_x3,
      d => coefficient_rom_data_net,
      en => '1',
      q => r1_q_net_x0
    );

  r2: entity work.xldelay
    generic map (
      latency => 1,
      reg_retiming => 0,
      width => 1
    )
    port map (
      ce => ce_1_sg_x3,
      clk => clk_1_sg_x3,
      d(0) => relational1_op_net,
      en => '1',
      q(0) => r2_q_net_x0
    );

  r3: entity work.xldelay
    generic map (
      latency => 1,
      reg_retiming => 0,
      width => 8
    )
    port map (
      ce => ce_5_sg_x2,
      clk => clk_5_sg_x2,
      d => single_port_ram_data_out_net_x0,
      en => '1',
      q => r3_q_net
    );

  relational1: entity work.relational1_4c0cd11c3f
    port map (
      a => counter_op_net,
      b(0) => constant_0_op_net,
      ce => ce_1_sg_x3,
      clk => clk_1_sg_x3,
      clr => '0',
      op(0) => relational1_op_net
    );

end structural;
library IEEE;
use IEEE.std_logic_1164.all;
use work.conv_pkg.all;

-- Generated from Simulink block "edgePenh/5x5Filter1/n-tap MAC FIR Filter2/MAC Engine"

entity mac_engine_entity_6bdc2f314d is
  port (
    a: in std_logic_vector(7 downto 0);
    b: in std_logic_vector(5 downto 0);
    ce_1: in std_logic;
    clk_1: in std_logic;
    rst: in std_logic;
    q: out std_logic_vector(9 downto 0)
  );
end mac_engine_entity_6bdc2f314d;

architecture structural of mac_engine_entity_6bdc2f314d is
  signal accumulator_q_net_x0: std_logic_vector(9 downto 0);
  signal ce_1_sg_x4: std_logic;
  signal clk_1_sg_x4: std_logic;
  signal mult_p_net: std_logic_vector(8 downto 0);
  signal r0_q_net_x0: std_logic_vector(7 downto 0);
  signal r1_q_net_x0: std_logic_vector(5 downto 0);
  signal r2_q_net_x0: std_logic;

begin
  r0_q_net_x0 <= a;
  r1_q_net_x0 <= b;
  ce_1_sg_x4 <= ce_1;
  clk_1_sg_x4 <= clk_1;
  r2_q_net_x0 <= rst;
  q <= accumulator_q_net_x0;

  accumulator: entity work.accumulator_2f069492a5
    port map (
      b => mult_p_net,
      ce => ce_1_sg_x4,
      clk => clk_1_sg_x4,
      clr => '0',
      rst(0) => r2_q_net_x0,
      q => accumulator_q_net_x0
    );

  mult: entity work.xlmult_v9_0
    generic map (
      a_arith => xlUnsigned,
      a_bin_pt => 0,
      a_width => 8,
      b_arith => xlSigned,
      b_bin_pt => 0,
      b_width => 6,
      c_a_type => 1,
      c_a_width => 8,
      c_b_type => 0,
      c_b_width => 6,
      c_baat => 8,
      c_output_width => 14,
      c_type => 0,
      core_name0 => "multiplier_virtex2p_10_0_102eaf484ea01e39",
      extra_registers => 0,
      multsign => 2,
      overflow => 1,
      p_arith => xlSigned,
      p_bin_pt => 0,
      p_width => 9,
      quantization => 1
    )
    port map (
      a => r0_q_net_x0,
      b => r1_q_net_x0,
      ce => ce_1_sg_x4,
      clk => clk_1_sg_x4,
      clr => '0',
      core_ce => ce_1_sg_x4,
      core_clk => clk_1_sg_x4,
      core_clr => '1',
      en => "1",
      rst => "0",
      p => mult_p_net
    );

end structural;
library IEEE;
use IEEE.std_logic_1164.all;
use work.conv_pkg.all;

-- Generated from Simulink block "edgePenh/5x5Filter1/n-tap MAC FIR Filter2"

entity n_tap_mac_fir_filter2_entity_bde2395848 is
  port (
    ce_1: in std_logic;
    ce_5: in std_logic;
    clk_1: in std_logic;
    clk_5: in std_logic;
    din: in std_logic_vector(7 downto 0);
    dout: out std_logic_vector(9 downto 0)
  );
end n_tap_mac_fir_filter2_entity_bde2395848;

architecture structural of n_tap_mac_fir_filter2_entity_bde2395848 is
  signal accumulator_q_net_x0: std_logic_vector(9 downto 0);
  signal asr_q_net: std_logic_vector(7 downto 0);
  signal capture_register_q_net: std_logic_vector(9 downto 0);
  signal ce_1_sg_x5: std_logic;
  signal ce_5_sg_x3: std_logic;
  signal clk_1_sg_x5: std_logic;
  signal clk_5_sg_x3: std_logic;
  signal coefficient_rom_data_net: std_logic_vector(5 downto 0);
  signal constant_0_op_net: std_logic;
  signal counter_op_net: std_logic_vector(2 downto 0);
  signal down_sample1_q_net_x0: std_logic_vector(9 downto 0);
  signal r0_q_net_x0: std_logic_vector(7 downto 0);
  signal r1_q_net_x0: std_logic_vector(5 downto 0);
  signal r2_q_net_x0: std_logic;
  signal r3_q_net: std_logic_vector(7 downto 0);
  signal relational1_op_net: std_logic;
  signal single_port_ram_data_out_net_x0: std_logic_vector(7 downto 0);

begin
  ce_1_sg_x5 <= ce_1;
  ce_5_sg_x3 <= ce_5;
  clk_1_sg_x5 <= clk_1;
  clk_5_sg_x3 <= clk_5;
  single_port_ram_data_out_net_x0 <= din;
  dout <= down_sample1_q_net_x0;

  asr: entity work.xladdrsr
    generic map (
      addr_arith => xlUnsigned,
      addr_bin_pt => 0,
      addr_width => 3,
      core_addr_width => 3,
      core_name0 => "asr_70_v2p_f089efcdbda572f6",
      d_arith => xlUnsigned,
      d_bin_pt => 0,
      d_width => 8,
      q_arith => xlUnsigned,
      q_bin_pt => 0,
      q_width => 8
    )
    port map (
      addr => counter_op_net,
      ce => ce_5_sg_x3,
      clk => clk_5_sg_x3,
      clr => '0',
      d => r3_q_net,
      en => "1",
      q => asr_q_net
    );

  capture_register: entity work.xlregister
    generic map (
      d_width => 10,
      init_value => b"0000000000"
    )
    port map (
      ce => ce_1_sg_x5,
      clk => clk_1_sg_x5,
      d => accumulator_q_net_x0,
      en(0) => r2_q_net_x0,
      rst => "0",
      q => capture_register_q_net
    );

  coefficient_rom: entity work.xlsprom
    generic map (
      c_address_width => 3,
      c_width => 6,
      core_name0 => "single_port_block_memory_virtex2p_6_1_eb8e8636b6ae267d",
      latency => 1
    )
    port map (
      addr => counter_op_net,
      ce => ce_1_sg_x5,
      clk => clk_1_sg_x5,
      en => "1",
      rst => "0",
      data => coefficient_rom_data_net
    );

  constant_0: entity work.constant_0_4750a0be1f
    port map (
      ce => '0',
      clk => '0',
      clr => '0',
      op(0) => constant_0_op_net
    );

  counter: entity work.xlcounter_limit
    generic map (
      cnt_15_0 => 4,
      cnt_31_16 => 0,
      cnt_47_32 => 0,
      cnt_63_48 => 0,
      core_name0 => "binary_counter_virtex2p_7_0_2678e693f726e29c",
      count_limited => 1,
      op_arith => xlUnsigned,
      op_width => 3
    )
    port map (
      ce => ce_1_sg_x5,
      clk => clk_1_sg_x5,
      clr => '0',
      en => "1",
      rst => "0",
      op => counter_op_net
    );

  down_sample1: entity work.xldsamp
    generic map (
      d_arith => xlSigned,
      d_bin_pt => 0,
      d_width => 10,
      ds_ratio => 5,
      latency => 1,
      phase => 4,
      q_arith => xlSigned,
      q_bin_pt => 0,
      q_width => 10
    )
    port map (
      d => capture_register_q_net,
      dest_ce => ce_5_sg_x3,
      dest_clk => clk_5_sg_x3,
      dest_clr => '0',
      en => "1",
      src_ce => ce_1_sg_x5,
      src_clk => clk_1_sg_x5,
      src_clr => '0',
      q => down_sample1_q_net_x0
    );

  mac_engine_6bdc2f314d: entity work.mac_engine_entity_6bdc2f314d
    port map (
      a => r0_q_net_x0,
      b => r1_q_net_x0,
      ce_1 => ce_1_sg_x5,
      clk_1 => clk_1_sg_x5,
      rst => r2_q_net_x0,
      q => accumulator_q_net_x0
    );

  r0: entity work.xldelay
    generic map (
      latency => 2,
      reg_retiming => 0,
      width => 8
    )
    port map (
      ce => ce_1_sg_x5,
      clk => clk_1_sg_x5,
      d => asr_q_net,
      en => '1',
      q => r0_q_net_x0
    );

  r1: entity work.xldelay
    generic map (
      latency => 1,
      reg_retiming => 0,
      width => 6
    )
    port map (
      ce => ce_1_sg_x5,
      clk => clk_1_sg_x5,
      d => coefficient_rom_data_net,
      en => '1',
      q => r1_q_net_x0
    );

  r2: entity work.xldelay
    generic map (
      latency => 1,
      reg_retiming => 0,
      width => 1
    )
    port map (
      ce => ce_1_sg_x5,
      clk => clk_1_sg_x5,
      d(0) => relational1_op_net,
      en => '1',
      q(0) => r2_q_net_x0
    );

  r3: entity work.xldelay
    generic map (
      latency => 1,
      reg_retiming => 0,
      width => 8
    )
    port map (
      ce => ce_5_sg_x3,
      clk => clk_5_sg_x3,
      d => single_port_ram_data_out_net_x0,
      en => '1',
      q => r3_q_net
    );

  relational1: entity work.relational1_4c0cd11c3f
    port map (
      a => counter_op_net,
      b(0) => constant_0_op_net,
      ce => ce_1_sg_x5,
      clk => clk_1_sg_x5,
      clr => '0',
      op(0) => relational1_op_net
    );

end structural;
library IEEE;
use IEEE.std_logic_1164.all;
use work.conv_pkg.all;

-- Generated from Simulink block "edgePenh/5x5Filter1/n-tap MAC FIR Filter3/MAC Engine"

entity mac_engine_entity_a980ef4360 is
  port (
    a: in std_logic_vector(7 downto 0);
    b: in std_logic_vector(5 downto 0);
    ce_1: in std_logic;
    clk_1: in std_logic;
    rst: in std_logic;
    q: out std_logic_vector(9 downto 0)
  );
end mac_engine_entity_a980ef4360;

architecture structural of mac_engine_entity_a980ef4360 is
  signal accumulator_q_net_x0: std_logic_vector(9 downto 0);
  signal ce_1_sg_x6: std_logic;
  signal clk_1_sg_x6: std_logic;
  signal mult_p_net: std_logic_vector(8 downto 0);
  signal r0_q_net_x0: std_logic_vector(7 downto 0);
  signal r1_q_net_x0: std_logic_vector(5 downto 0);
  signal r2_q_net_x0: std_logic;

begin
  r0_q_net_x0 <= a;
  r1_q_net_x0 <= b;
  ce_1_sg_x6 <= ce_1;
  clk_1_sg_x6 <= clk_1;
  r2_q_net_x0 <= rst;
  q <= accumulator_q_net_x0;

  accumulator: entity work.accumulator_2f069492a5
    port map (
      b => mult_p_net,
      ce => ce_1_sg_x6,
      clk => clk_1_sg_x6,
      clr => '0',
      rst(0) => r2_q_net_x0,
      q => accumulator_q_net_x0
    );

  mult: entity work.xlmult_v9_0
    generic map (
      a_arith => xlUnsigned,
      a_bin_pt => 0,
      a_width => 8,
      b_arith => xlSigned,
      b_bin_pt => 0,
      b_width => 6,
      c_a_type => 1,
      c_a_width => 8,
      c_b_type => 0,
      c_b_width => 6,
      c_baat => 8,
      c_output_width => 14,
      c_type => 0,
      core_name0 => "multiplier_virtex2p_10_0_102eaf484ea01e39",
      extra_registers => 0,
      multsign => 2,
      overflow => 1,
      p_arith => xlSigned,
      p_bin_pt => 0,
      p_width => 9,
      quantization => 1
    )
    port map (
      a => r0_q_net_x0,
      b => r1_q_net_x0,
      ce => ce_1_sg_x6,
      clk => clk_1_sg_x6,
      clr => '0',
      core_ce => ce_1_sg_x6,
      core_clk => clk_1_sg_x6,
      core_clr => '1',
      en => "1",
      rst => "0",
      p => mult_p_net
    );

end structural;
library IEEE;
use IEEE.std_logic_1164.all;
use work.conv_pkg.all;

-- Generated from Simulink block "edgePenh/5x5Filter1/n-tap MAC FIR Filter3"

entity n_tap_mac_fir_filter3_entity_52aece936c is
  port (
    ce_1: in std_logic;
    ce_5: in std_logic;
    clk_1: in std_logic;
    clk_5: in std_logic;
    din: in std_logic_vector(7 downto 0);
    dout: out std_logic_vector(9 downto 0)
  );
end n_tap_mac_fir_filter3_entity_52aece936c;

architecture structural of n_tap_mac_fir_filter3_entity_52aece936c is
  signal accumulator_q_net_x0: std_logic_vector(9 downto 0);
  signal asr_q_net: std_logic_vector(7 downto 0);
  signal capture_register_q_net: std_logic_vector(9 downto 0);
  signal ce_1_sg_x7: std_logic;
  signal ce_5_sg_x4: std_logic;
  signal clk_1_sg_x7: std_logic;
  signal clk_5_sg_x4: std_logic;
  signal coefficient_rom_data_net: std_logic_vector(5 downto 0);
  signal constant_0_op_net: std_logic;
  signal counter_op_net: std_logic_vector(2 downto 0);
  signal down_sample1_q_net_x0: std_logic_vector(9 downto 0);
  signal r0_q_net_x0: std_logic_vector(7 downto 0);
  signal r1_q_net_x0: std_logic_vector(5 downto 0);
  signal r2_q_net_x0: std_logic;
  signal r3_q_net: std_logic_vector(7 downto 0);
  signal relational1_op_net: std_logic;
  signal single_port_ram_data_out_net_x0: std_logic_vector(7 downto 0);

begin
  ce_1_sg_x7 <= ce_1;
  ce_5_sg_x4 <= ce_5;
  clk_1_sg_x7 <= clk_1;
  clk_5_sg_x4 <= clk_5;
  single_port_ram_data_out_net_x0 <= din;
  dout <= down_sample1_q_net_x0;

  asr: entity work.xladdrsr
    generic map (
      addr_arith => xlUnsigned,
      addr_bin_pt => 0,
      addr_width => 3,
      core_addr_width => 3,
      core_name0 => "asr_70_v2p_f089efcdbda572f6",
      d_arith => xlUnsigned,
      d_bin_pt => 0,
      d_width => 8,
      q_arith => xlUnsigned,
      q_bin_pt => 0,
      q_width => 8
    )
    port map (
      addr => counter_op_net,
      ce => ce_5_sg_x4,
      clk => clk_5_sg_x4,
      clr => '0',
      d => r3_q_net,
      en => "1",
      q => asr_q_net
    );

  capture_register: entity work.xlregister
    generic map (
      d_width => 10,
      init_value => b"0000000000"
    )
    port map (
      ce => ce_1_sg_x7,
      clk => clk_1_sg_x7,
      d => accumulator_q_net_x0,
      en(0) => r2_q_net_x0,
      rst => "0",
      q => capture_register_q_net
    );

  coefficient_rom: entity work.xlsprom
    generic map (
      c_address_width => 3,
      c_width => 6,
      core_name0 => "single_port_block_memory_virtex2p_6_1_f3f458326da29b49",
      latency => 1
    )
    port map (
      addr => counter_op_net,
      ce => ce_1_sg_x7,
      clk => clk_1_sg_x7,
      en => "1",
      rst => "0",
      data => coefficient_rom_data_net
    );

  constant_0: entity work.constant_0_4750a0be1f
    port map (
      ce => '0',
      clk => '0',
      clr => '0',
      op(0) => constant_0_op_net
    );

  counter: entity work.xlcounter_limit
    generic map (
      cnt_15_0 => 4,
      cnt_31_16 => 0,
      cnt_47_32 => 0,
      cnt_63_48 => 0,
      core_name0 => "binary_counter_virtex2p_7_0_2678e693f726e29c",
      count_limited => 1,
      op_arith => xlUnsigned,
      op_width => 3
    )
    port map (
      ce => ce_1_sg_x7,
      clk => clk_1_sg_x7,
      clr => '0',
      en => "1",
      rst => "0",
      op => counter_op_net
    );

  down_sample1: entity work.xldsamp
    generic map (
      d_arith => xlSigned,
      d_bin_pt => 0,
      d_width => 10,
      ds_ratio => 5,
      latency => 1,
      phase => 4,
      q_arith => xlSigned,
      q_bin_pt => 0,
      q_width => 10
    )
    port map (
      d => capture_register_q_net,
      dest_ce => ce_5_sg_x4,
      dest_clk => clk_5_sg_x4,
      dest_clr => '0',
      en => "1",
      src_ce => ce_1_sg_x7,
      src_clk => clk_1_sg_x7,
      src_clr => '0',
      q => down_sample1_q_net_x0
    );

  mac_engine_a980ef4360: entity work.mac_engine_entity_a980ef4360
    port map (
      a => r0_q_net_x0,
      b => r1_q_net_x0,
      ce_1 => ce_1_sg_x7,
      clk_1 => clk_1_sg_x7,
      rst => r2_q_net_x0,
      q => accumulator_q_net_x0
    );

  r0: entity work.xldelay
    generic map (
      latency => 2,
      reg_retiming => 0,
      width => 8
    )
    port map (
      ce => ce_1_sg_x7,
      clk => clk_1_sg_x7,
      d => asr_q_net,
      en => '1',
      q => r0_q_net_x0
    );

  r1: entity work.xldelay
    generic map (
      latency => 1,
      reg_retiming => 0,
      width => 6
    )
    port map (
      ce => ce_1_sg_x7,
      clk => clk_1_sg_x7,
      d => coefficient_rom_data_net,
      en => '1',
      q => r1_q_net_x0
    );

  r2: entity work.xldelay
    generic map (
      latency => 1,
      reg_retiming => 0,
      width => 1
    )
    port map (
      ce => ce_1_sg_x7,
      clk => clk_1_sg_x7,
      d(0) => relational1_op_net,
      en => '1',
      q(0) => r2_q_net_x0
    );

  r3: entity work.xldelay
    generic map (
      latency => 1,
      reg_retiming => 0,
      width => 8
    )
    port map (
      ce => ce_5_sg_x4,
      clk => clk_5_sg_x4,
      d => single_port_ram_data_out_net_x0,
      en => '1',
      q => r3_q_net
    );

  relational1: entity work.relational1_4c0cd11c3f
    port map (
      a => counter_op_net,
      b(0) => constant_0_op_net,
      ce => ce_1_sg_x7,
      clk => clk_1_sg_x7,
      clr => '0',
      op(0) => relational1_op_net
    );

end structural;
library IEEE;
use IEEE.std_logic_1164.all;
use work.conv_pkg.all;

-- Generated from Simulink block "edgePenh/5x5Filter1/n-tap MAC FIR Filter4/MAC Engine"

entity mac_engine_entity_e3d199895d is
  port (
    a: in std_logic_vector(7 downto 0);
    b: in std_logic_vector(5 downto 0);
    ce_1: in std_logic;
    clk_1: in std_logic;
    rst: in std_logic;
    q: out std_logic_vector(8 downto 0)
  );
end mac_engine_entity_e3d199895d;

architecture structural of mac_engine_entity_e3d199895d is
  signal accumulator_q_net_x0: std_logic_vector(8 downto 0);
  signal ce_1_sg_x8: std_logic;
  signal clk_1_sg_x8: std_logic;
  signal mult_p_net: std_logic_vector(8 downto 0);
  signal r0_q_net_x0: std_logic_vector(7 downto 0);
  signal r1_q_net_x0: std_logic_vector(5 downto 0);
  signal r2_q_net_x0: std_logic;

begin
  r0_q_net_x0 <= a;
  r1_q_net_x0 <= b;
  ce_1_sg_x8 <= ce_1;
  clk_1_sg_x8 <= clk_1;
  r2_q_net_x0 <= rst;
  q <= accumulator_q_net_x0;

  accumulator: entity work.accumulator_620e80e3aa
    port map (
      b => mult_p_net,
      ce => ce_1_sg_x8,
      clk => clk_1_sg_x8,
      clr => '0',
      rst(0) => r2_q_net_x0,
      q => accumulator_q_net_x0
    );

  mult: entity work.xlmult_v9_0
    generic map (
      a_arith => xlUnsigned,
      a_bin_pt => 0,
      a_width => 8,
      b_arith => xlSigned,
      b_bin_pt => 0,
      b_width => 6,
      c_a_type => 1,
      c_a_width => 8,
      c_b_type => 0,
      c_b_width => 6,
      c_baat => 8,
      c_output_width => 14,
      c_type => 0,
      core_name0 => "multiplier_virtex2p_10_0_102eaf484ea01e39",
      extra_registers => 0,
      multsign => 2,
      overflow => 1,
      p_arith => xlSigned,
      p_bin_pt => 0,
      p_width => 9,
      quantization => 1
    )
    port map (
      a => r0_q_net_x0,
      b => r1_q_net_x0,
      ce => ce_1_sg_x8,
      clk => clk_1_sg_x8,
      clr => '0',
      core_ce => ce_1_sg_x8,
      core_clk => clk_1_sg_x8,
      core_clr => '1',
      en => "1",
      rst => "0",
      p => mult_p_net
    );

end structural;
library IEEE;
use IEEE.std_logic_1164.all;
use work.conv_pkg.all;

-- Generated from Simulink block "edgePenh/5x5Filter1/n-tap MAC FIR Filter4"

entity n_tap_mac_fir_filter4_entity_372d5b4c50 is
  port (
    ce_1: in std_logic;
    ce_5: in std_logic;
    clk_1: in std_logic;
    clk_5: in std_logic;
    din: in std_logic_vector(7 downto 0);
    dout: out std_logic_vector(8 downto 0)
  );
end n_tap_mac_fir_filter4_entity_372d5b4c50;

architecture structural of n_tap_mac_fir_filter4_entity_372d5b4c50 is
  signal accumulator_q_net_x0: std_logic_vector(8 downto 0);
  signal asr_q_net: std_logic_vector(7 downto 0);
  signal capture_register_q_net: std_logic_vector(8 downto 0);
  signal ce_1_sg_x9: std_logic;
  signal ce_5_sg_x5: std_logic;
  signal clk_1_sg_x9: std_logic;
  signal clk_5_sg_x5: std_logic;
  signal coefficient_rom_data_net: std_logic_vector(5 downto 0);
  signal constant_0_op_net: std_logic;
  signal counter_op_net: std_logic_vector(2 downto 0);
  signal down_sample1_q_net_x0: std_logic_vector(8 downto 0);
  signal r0_q_net_x0: std_logic_vector(7 downto 0);
  signal r1_q_net_x0: std_logic_vector(5 downto 0);
  signal r2_q_net_x0: std_logic;
  signal r3_q_net: std_logic_vector(7 downto 0);
  signal register16_q_net_x0: std_logic_vector(7 downto 0);
  signal relational1_op_net: std_logic;

begin
  ce_1_sg_x9 <= ce_1;
  ce_5_sg_x5 <= ce_5;
  clk_1_sg_x9 <= clk_1;
  clk_5_sg_x5 <= clk_5;
  register16_q_net_x0 <= din;
  dout <= down_sample1_q_net_x0;

  asr: entity work.xladdrsr
    generic map (
      addr_arith => xlUnsigned,
      addr_bin_pt => 0,
      addr_width => 3,
      core_addr_width => 3,
      core_name0 => "asr_70_v2p_f089efcdbda572f6",
      d_arith => xlUnsigned,
      d_bin_pt => 0,
      d_width => 8,
      q_arith => xlUnsigned,
      q_bin_pt => 0,
      q_width => 8
    )
    port map (
      addr => counter_op_net,
      ce => ce_5_sg_x5,
      clk => clk_5_sg_x5,
      clr => '0',
      d => r3_q_net,
      en => "1",
      q => asr_q_net
    );

  capture_register: entity work.xlregister
    generic map (
      d_width => 9,
      init_value => b"000000000"
    )
    port map (
      ce => ce_1_sg_x9,
      clk => clk_1_sg_x9,
      d => accumulator_q_net_x0,
      en(0) => r2_q_net_x0,
      rst => "0",
      q => capture_register_q_net
    );

  coefficient_rom: entity work.xlsprom
    generic map (
      c_address_width => 3,
      c_width => 6,
      core_name0 => "single_port_block_memory_virtex2p_6_1_7d992e82f841c975",
      latency => 1
    )
    port map (
      addr => counter_op_net,
      ce => ce_1_sg_x9,
      clk => clk_1_sg_x9,
      en => "1",
      rst => "0",
      data => coefficient_rom_data_net
    );

  constant_0: entity work.constant_0_4750a0be1f
    port map (
      ce => '0',
      clk => '0',
      clr => '0',
      op(0) => constant_0_op_net
    );

  counter: entity work.xlcounter_limit
    generic map (
      cnt_15_0 => 4,
      cnt_31_16 => 0,
      cnt_47_32 => 0,
      cnt_63_48 => 0,
      core_name0 => "binary_counter_virtex2p_7_0_2678e693f726e29c",
      count_limited => 1,
      op_arith => xlUnsigned,
      op_width => 3
    )
    port map (
      ce => ce_1_sg_x9,
      clk => clk_1_sg_x9,
      clr => '0',
      en => "1",
      rst => "0",
      op => counter_op_net
    );

  down_sample1: entity work.xldsamp
    generic map (
      d_arith => xlSigned,
      d_bin_pt => 0,
      d_width => 9,
      ds_ratio => 5,
      latency => 1,
      phase => 4,
      q_arith => xlSigned,
      q_bin_pt => 0,
      q_width => 9
    )
    port map (
      d => capture_register_q_net,
      dest_ce => ce_5_sg_x5,
      dest_clk => clk_5_sg_x5,
      dest_clr => '0',
      en => "1",
      src_ce => ce_1_sg_x9,
      src_clk => clk_1_sg_x9,
      src_clr => '0',
      q => down_sample1_q_net_x0
    );

  mac_engine_e3d199895d: entity work.mac_engine_entity_e3d199895d
    port map (
      a => r0_q_net_x0,
      b => r1_q_net_x0,
      ce_1 => ce_1_sg_x9,
      clk_1 => clk_1_sg_x9,
      rst => r2_q_net_x0,
      q => accumulator_q_net_x0
    );

  r0: entity work.xldelay
    generic map (
      latency => 2,
      reg_retiming => 0,
      width => 8
    )
    port map (
      ce => ce_1_sg_x9,
      clk => clk_1_sg_x9,
      d => asr_q_net,
      en => '1',
      q => r0_q_net_x0
    );

  r1: entity work.xldelay
    generic map (
      latency => 1,
      reg_retiming => 0,
      width => 6
    )
    port map (
      ce => ce_1_sg_x9,
      clk => clk_1_sg_x9,
      d => coefficient_rom_data_net,
      en => '1',
      q => r1_q_net_x0
    );

  r2: entity work.xldelay
    generic map (
      latency => 1,
      reg_retiming => 0,
      width => 1
    )
    port map (
      ce => ce_1_sg_x9,
      clk => clk_1_sg_x9,
      d(0) => relational1_op_net,
      en => '1',
      q(0) => r2_q_net_x0
    );

  r3: entity work.xldelay
    generic map (
      latency => 1,
      reg_retiming => 0,
      width => 8
    )
    port map (
      ce => ce_5_sg_x5,
      clk => clk_5_sg_x5,
      d => register16_q_net_x0,
      en => '1',
      q => r3_q_net
    );

  relational1: entity work.relational1_4c0cd11c3f
    port map (
      a => counter_op_net,
      b(0) => constant_0_op_net,
      ce => ce_1_sg_x9,
      clk => clk_1_sg_x9,
      clr => '0',
      op(0) => relational1_op_net
    );

end structural;
library IEEE;
use IEEE.std_logic_1164.all;
use work.conv_pkg.all;

-- Generated from Simulink block "edgePenh/5x5Filter1"

entity x5x5filter1_entity_0b951638cd is
  port (
    ce_1: in std_logic;
    ce_5: in std_logic;
    clk_1: in std_logic;
    clk_5: in std_logic;
    line1: in std_logic_vector(7 downto 0);
    line2: in std_logic_vector(7 downto 0);
    line3: in std_logic_vector(7 downto 0);
    line4: in std_logic_vector(7 downto 0);
    line5: in std_logic_vector(7 downto 0);
    out1: out std_logic_vector(7 downto 0)
  );
end x5x5filter1_entity_0b951638cd;

architecture structural of x5x5filter1_entity_0b951638cd is
  signal addsub15_s_net_x0: std_logic_vector(12 downto 0);
  signal addsub2_s_net: std_logic_vector(10 downto 0);
  signal addsub3_s_net: std_logic_vector(10 downto 0);
  signal addsub4_s_net: std_logic_vector(11 downto 0);
  signal ce_1_sg_x10: std_logic;
  signal ce_5_sg_x6: std_logic;
  signal clk_1_sg_x10: std_logic;
  signal clk_5_sg_x6: std_logic;
  signal cmult_p_net: std_logic_vector(31 downto 0);
  signal convert1_dout_net_x0: std_logic_vector(7 downto 0);
  signal down_sample1_q_net_x0: std_logic_vector(8 downto 0);
  signal down_sample1_q_net_x1: std_logic_vector(9 downto 0);
  signal down_sample1_q_net_x2: std_logic_vector(9 downto 0);
  signal down_sample1_q_net_x3: std_logic_vector(9 downto 0);
  signal down_sample1_q_net_x4: std_logic_vector(8 downto 0);
  signal mux_y_net_x0: std_logic_vector(13 downto 0);
  signal register16_q_net_x1: std_logic_vector(7 downto 0);
  signal register1_q_net: std_logic_vector(8 downto 0);
  signal register2_q_net: std_logic_vector(8 downto 0);
  signal single_port_ram_data_out_net_x4: std_logic_vector(7 downto 0);
  signal single_port_ram_data_out_net_x5: std_logic_vector(7 downto 0);
  signal single_port_ram_data_out_net_x6: std_logic_vector(7 downto 0);
  signal single_port_ram_data_out_net_x7: std_logic_vector(7 downto 0);

begin
  ce_1_sg_x10 <= ce_1;
  ce_5_sg_x6 <= ce_5;
  clk_1_sg_x10 <= clk_1;
  clk_5_sg_x6 <= clk_5;
  single_port_ram_data_out_net_x7 <= line1;
  single_port_ram_data_out_net_x6 <= line2;
  single_port_ram_data_out_net_x5 <= line3;
  single_port_ram_data_out_net_x4 <= line4;
  register16_q_net_x1 <= line5;
  out1 <= convert1_dout_net_x0;

  abs1_ba1e9f5ee5: entity work.abs1_entity_ba1e9f5ee5
    port map (
      ce_5 => ce_5_sg_x6,
      clk_5 => clk_5_sg_x6,
      in1 => addsub15_s_net_x0,
      out1 => mux_y_net_x0
    );

  addsub15: entity work.xladdsub
    generic map (
      a_arith => xlSigned,
      a_bin_pt => 0,
      a_width => 12,
      b_arith => xlSigned,
      b_bin_pt => 0,
      b_width => 9,
      c_has_b_out => 0,
      c_has_c_out => 0,
      c_has_q => 1,
      c_has_q_b_out => 0,
      c_has_q_c_out => 0,
      c_has_s => 0,
      c_latency => 1,
      c_output_width => 13,
      core_name0 => "adder_subtracter_virtex2p_7_0_157a7954c44ca5c9",
      extra_registers => 0,
      full_s_arith => 2,
      full_s_width => 13,
      latency => 1,
      mode => 1,
      overflow => 1,
      quantization => 1,
      s_arith => xlSigned,
      s_bin_pt => 0,
      s_width => 13
    )
    port map (
      a => addsub4_s_net,
      b => register2_q_net,
      ce => ce_5_sg_x6,
      clk => clk_5_sg_x6,
      clr => '0',
      en => "1",
      s => addsub15_s_net_x0
    );

  addsub2: entity work.xladdsub
    generic map (
      a_arith => xlSigned,
      a_bin_pt => 0,
      a_width => 9,
      b_arith => xlSigned,
      b_bin_pt => 0,
      b_width => 10,
      c_has_b_out => 0,
      c_has_c_out => 0,
      c_has_q => 1,
      c_has_q_b_out => 0,
      c_has_q_c_out => 0,
      c_has_s => 0,
      c_latency => 1,
      c_output_width => 11,
      core_name0 => "adder_subtracter_virtex2p_7_0_458210000024155d",
      extra_registers => 0,
      full_s_arith => 2,
      full_s_width => 11,
      latency => 1,
      mode => 1,
      overflow => 1,
      quantization => 1,
      s_arith => xlSigned,
      s_bin_pt => 0,
      s_width => 11
    )
    port map (
      a => down_sample1_q_net_x0,
      b => down_sample1_q_net_x1,
      ce => ce_5_sg_x6,
      clk => clk_5_sg_x6,
      clr => '0',
      en => "1",
      s => addsub2_s_net
    );

  addsub3: entity work.xladdsub
    generic map (
      a_arith => xlSigned,
      a_bin_pt => 0,
      a_width => 10,
      b_arith => xlSigned,
      b_bin_pt => 0,
      b_width => 10,
      c_has_b_out => 0,
      c_has_c_out => 0,
      c_has_q => 1,
      c_has_q_b_out => 0,
      c_has_q_c_out => 0,
      c_has_s => 0,
      c_latency => 1,
      c_output_width => 11,
      core_name0 => "adder_subtracter_virtex2p_7_0_458210000024155d",
      extra_registers => 0,
      full_s_arith => 2,
      full_s_width => 11,
      latency => 1,
      mode => 1,
      overflow => 1,
      quantization => 1,
      s_arith => xlSigned,
      s_bin_pt => 0,
      s_width => 11
    )
    port map (
      a => down_sample1_q_net_x2,
      b => down_sample1_q_net_x3,
      ce => ce_5_sg_x6,
      clk => clk_5_sg_x6,
      clr => '0',
      en => "1",
      s => addsub3_s_net
    );

  addsub4: entity work.xladdsub
    generic map (
      a_arith => xlSigned,
      a_bin_pt => 0,
      a_width => 11,
      b_arith => xlSigned,
      b_bin_pt => 0,
      b_width => 11,
      c_has_b_out => 0,
      c_has_c_out => 0,
      c_has_q => 1,
      c_has_q_b_out => 0,
      c_has_q_c_out => 0,
      c_has_s => 0,
      c_latency => 1,
      c_output_width => 12,
      core_name0 => "adder_subtracter_virtex2p_7_0_9a9feaafe28a54ba",
      extra_registers => 0,
      full_s_arith => 2,
      full_s_width => 12,
      latency => 1,
      mode => 1,
      overflow => 1,
      quantization => 1,
      s_arith => xlSigned,
      s_bin_pt => 0,
      s_width => 12
    )
    port map (
      a => addsub2_s_net,
      b => addsub3_s_net,
      ce => ce_5_sg_x6,
      clk => clk_5_sg_x6,
      clr => '0',
      en => "1",
      s => addsub4_s_net
    );

  cmult: entity work.xlcmult
    generic map (
      a_arith => xlSigned,
      a_bin_pt => 0,
      a_width => 14,
      b_bin_pt => 17,
      c_a_type => 0,
      c_a_width => 14,
      c_b_type => 1,
      c_b_width => 18,
      c_output_width => 32,
      core_name0 => "multiplier_virtex2p_7_0_7cd01ad983d2345c",
      extra_registers => 3,
      latency => 4,
      multsign => 2,
      overflow => 1,
      oversample => 1,
      p_arith => xlSigned,
      p_bin_pt => 17,
      p_width => 32,
      quantization => 1,
      zero_const => 0
    )
    port map (
      a => mux_y_net_x0,
      ce => ce_5_sg_x6,
      clk => clk_5_sg_x6,
      clr => '0',
      core_ce => ce_5_sg_x6,
      core_clk => clk_5_sg_x6,
      core_clr => '1',
      en => "1",
      rst => "0",
      p => cmult_p_net
    );

  convert1: entity work.xlconvert
    generic map (
      bool_conversion => 0,
      din_arith => 2,
      din_bin_pt => 17,
      din_width => 32,
      dout_arith => 1,
      dout_bin_pt => 0,
      dout_width => 8,
      latency => 1,
      overflow => xlSaturate,
      quantization => xlTruncate
    )
    port map (
      ce => ce_5_sg_x6,
      clk => clk_5_sg_x6,
      clr => '0',
      din => cmult_p_net,
      dout => convert1_dout_net_x0
    );

  n_tap_mac_fir_filter1_98437ef112: entity work.n_tap_mac_fir_filter1_entity_98437ef112
    port map (
      ce_1 => ce_1_sg_x10,
      ce_5 => ce_5_sg_x6,
      clk_1 => clk_1_sg_x10,
      clk_5 => clk_5_sg_x6,
      din => single_port_ram_data_out_net_x6,
      dout => down_sample1_q_net_x1
    );

  n_tap_mac_fir_filter2_bde2395848: entity work.n_tap_mac_fir_filter2_entity_bde2395848
    port map (
      ce_1 => ce_1_sg_x10,
      ce_5 => ce_5_sg_x6,
      clk_1 => clk_1_sg_x10,
      clk_5 => clk_5_sg_x6,
      din => single_port_ram_data_out_net_x5,
      dout => down_sample1_q_net_x2
    );

  n_tap_mac_fir_filter3_52aece936c: entity work.n_tap_mac_fir_filter3_entity_52aece936c
    port map (
      ce_1 => ce_1_sg_x10,
      ce_5 => ce_5_sg_x6,
      clk_1 => clk_1_sg_x10,
      clk_5 => clk_5_sg_x6,
      din => single_port_ram_data_out_net_x4,
      dout => down_sample1_q_net_x3
    );

  n_tap_mac_fir_filter4_372d5b4c50: entity work.n_tap_mac_fir_filter4_entity_372d5b4c50
    port map (
      ce_1 => ce_1_sg_x10,
      ce_5 => ce_5_sg_x6,
      clk_1 => clk_1_sg_x10,
      clk_5 => clk_5_sg_x6,
      din => register16_q_net_x1,
      dout => down_sample1_q_net_x4
    );

  n_tap_mac_fir_filter_bc7b8b822c: entity work.n_tap_mac_fir_filter_entity_bc7b8b822c
    port map (
      ce_1 => ce_1_sg_x10,
      ce_5 => ce_5_sg_x6,
      clk_1 => clk_1_sg_x10,
      clk_5 => clk_5_sg_x6,
      din => single_port_ram_data_out_net_x7,
      dout => down_sample1_q_net_x0
    );

  register1: entity work.xlregister
    generic map (
      d_width => 9,
      init_value => b"000000000"
    )
    port map (
      ce => ce_5_sg_x6,
      clk => clk_5_sg_x6,
      d => down_sample1_q_net_x4,
      en => "1",
      rst => "0",
      q => register1_q_net
    );

  register2: entity work.xlregister
    generic map (
      d_width => 9,
      init_value => b"000000000"
    )
    port map (
      ce => ce_5_sg_x6,
      clk => clk_5_sg_x6,
      d => register1_q_net,
      en => "1",
      rst => "0",
      q => register2_q_net
    );

end structural;
library IEEE;
use IEEE.std_logic_1164.all;
use work.conv_pkg.all;

-- Generated from Simulink block "edgePenh/Virtex2 5 Line Buffer/Virtex2 Line Buffer"

entity virtex2_line_buffer_entity_902f095c97 is
  port (
    ce_5: in std_logic;
    clk_5: in std_logic;
    i: in std_logic_vector(7 downto 0);
    o: out std_logic_vector(7 downto 0)
  );
end virtex2_line_buffer_entity_902f095c97;

architecture structural of virtex2_line_buffer_entity_902f095c97 is
  signal ce_5_sg_x7: std_logic;
  signal clk_5_sg_x7: std_logic;
  signal constant3_op_net: std_logic;
  signal counter2_op_net: std_logic_vector(7 downto 0);
  signal register16_q_net_x2: std_logic_vector(7 downto 0);
  signal single_port_ram_data_out_net_x5: std_logic_vector(7 downto 0);

begin
  ce_5_sg_x7 <= ce_5;
  clk_5_sg_x7 <= clk_5;
  register16_q_net_x2 <= i;
  o <= single_port_ram_data_out_net_x5;

  constant3: entity work.constant3_bc1e67d7ac
    port map (
      ce => '0',
      clk => '0',
      clr => '0',
      op(0) => constant3_op_net
    );

  counter2: entity work.xlcounter_limit
    generic map (
      cnt_15_0 => 228,
      cnt_31_16 => 0,
      cnt_47_32 => 0,
      cnt_63_48 => 0,
      core_name0 => "binary_counter_virtex2p_7_0_ff2d32015ee9df2b",
      count_limited => 1,
      op_arith => xlUnsigned,
      op_width => 8
    )
    port map (
      ce => ce_5_sg_x7,
      clk => clk_5_sg_x7,
      clr => '0',
      en => "1",
      rst => "0",
      op => counter2_op_net
    );

  single_port_ram: entity work.xlspram
    generic map (
      c_address_width => 8,
      c_width => 8,
      core_name0 => "single_port_block_memory_virtex2p_6_1_9fca739df23a8df5",
      latency => 1
    )
    port map (
      addr => counter2_op_net,
      ce => ce_5_sg_x7,
      clk => clk_5_sg_x7,
      data_in => register16_q_net_x2,
      en => "1",
      rst => "0",
      we(0) => constant3_op_net,
      data_out => single_port_ram_data_out_net_x5
    );

end structural;
library IEEE;
use IEEE.std_logic_1164.all;
use work.conv_pkg.all;

-- Generated from Simulink block "edgePenh/Virtex2 5 Line Buffer/Virtex2 Line Buffer1"

entity virtex2_line_buffer1_entity_ba821f67ad is
  port (
    ce_5: in std_logic;
    clk_5: in std_logic;
    i: in std_logic_vector(7 downto 0);
    o: out std_logic_vector(7 downto 0)
  );
end virtex2_line_buffer1_entity_ba821f67ad;

architecture structural of virtex2_line_buffer1_entity_ba821f67ad is
  signal ce_5_sg_x8: std_logic;
  signal clk_5_sg_x8: std_logic;
  signal constant3_op_net: std_logic;
  signal counter2_op_net: std_logic_vector(7 downto 0);
  signal single_port_ram_data_out_net_x7: std_logic_vector(7 downto 0);
  signal single_port_ram_data_out_net_x8: std_logic_vector(7 downto 0);

begin
  ce_5_sg_x8 <= ce_5;
  clk_5_sg_x8 <= clk_5;
  single_port_ram_data_out_net_x7 <= i;
  o <= single_port_ram_data_out_net_x8;

  constant3: entity work.constant3_bc1e67d7ac
    port map (
      ce => '0',
      clk => '0',
      clr => '0',
      op(0) => constant3_op_net
    );

  counter2: entity work.xlcounter_limit
    generic map (
      cnt_15_0 => 228,
      cnt_31_16 => 0,
      cnt_47_32 => 0,
      cnt_63_48 => 0,
      core_name0 => "binary_counter_virtex2p_7_0_ff2d32015ee9df2b",
      count_limited => 1,
      op_arith => xlUnsigned,
      op_width => 8
    )
    port map (
      ce => ce_5_sg_x8,
      clk => clk_5_sg_x8,
      clr => '0',
      en => "1",
      rst => "0",
      op => counter2_op_net
    );

  single_port_ram: entity work.xlspram
    generic map (
      c_address_width => 8,
      c_width => 8,
      core_name0 => "single_port_block_memory_virtex2p_6_1_9fca739df23a8df5",
      latency => 1
    )
    port map (
      addr => counter2_op_net,
      ce => ce_5_sg_x8,
      clk => clk_5_sg_x8,
      data_in => single_port_ram_data_out_net_x7,
      en => "1",
      rst => "0",
      we(0) => constant3_op_net,
      data_out => single_port_ram_data_out_net_x8
    );

end structural;
library IEEE;
use IEEE.std_logic_1164.all;
use work.conv_pkg.all;

-- Generated from Simulink block "edgePenh/Virtex2 5 Line Buffer/Virtex2 Line Buffer2"

entity virtex2_line_buffer2_entity_5106f108fc is
  port (
    ce_5: in std_logic;
    clk_5: in std_logic;
    i: in std_logic_vector(7 downto 0);
    o: out std_logic_vector(7 downto 0)
  );
end virtex2_line_buffer2_entity_5106f108fc;

architecture structural of virtex2_line_buffer2_entity_5106f108fc is
  signal ce_5_sg_x9: std_logic;
  signal clk_5_sg_x9: std_logic;
  signal constant3_op_net: std_logic;
  signal counter2_op_net: std_logic_vector(7 downto 0);
  signal single_port_ram_data_out_net_x10: std_logic_vector(7 downto 0);
  signal single_port_ram_data_out_net_x9: std_logic_vector(7 downto 0);

begin
  ce_5_sg_x9 <= ce_5;
  clk_5_sg_x9 <= clk_5;
  single_port_ram_data_out_net_x9 <= i;
  o <= single_port_ram_data_out_net_x10;

  constant3: entity work.constant3_bc1e67d7ac
    port map (
      ce => '0',
      clk => '0',
      clr => '0',
      op(0) => constant3_op_net
    );

  counter2: entity work.xlcounter_limit
    generic map (
      cnt_15_0 => 228,
      cnt_31_16 => 0,
      cnt_47_32 => 0,
      cnt_63_48 => 0,
      core_name0 => "binary_counter_virtex2p_7_0_ff2d32015ee9df2b",
      count_limited => 1,
      op_arith => xlUnsigned,
      op_width => 8
    )
    port map (
      ce => ce_5_sg_x9,
      clk => clk_5_sg_x9,
      clr => '0',
      en => "1",
      rst => "0",
      op => counter2_op_net
    );

  single_port_ram: entity work.xlspram
    generic map (
      c_address_width => 8,
      c_width => 8,
      core_name0 => "single_port_block_memory_virtex2p_6_1_9fca739df23a8df5",
      latency => 1
    )
    port map (
      addr => counter2_op_net,
      ce => ce_5_sg_x9,
      clk => clk_5_sg_x9,
      data_in => single_port_ram_data_out_net_x9,
      en => "1",
      rst => "0",
      we(0) => constant3_op_net,
      data_out => single_port_ram_data_out_net_x10
    );

end structural;
library IEEE;
use IEEE.std_logic_1164.all;
use work.conv_pkg.all;

-- Generated from Simulink block "edgePenh/Virtex2 5 Line Buffer/Virtex2 Line Buffer3"

entity virtex2_line_buffer3_entity_9c9da1e081 is
  port (
    ce_5: in std_logic;
    clk_5: in std_logic;
    i: in std_logic_vector(7 downto 0);
    o: out std_logic_vector(7 downto 0)
  );
end virtex2_line_buffer3_entity_9c9da1e081;

architecture structural of virtex2_line_buffer3_entity_9c9da1e081 is
  signal ce_5_sg_x10: std_logic;
  signal clk_5_sg_x10: std_logic;
  signal constant3_op_net: std_logic;
  signal counter2_op_net: std_logic_vector(7 downto 0);
  signal single_port_ram_data_out_net_x11: std_logic_vector(7 downto 0);
  signal single_port_ram_data_out_net_x12: std_logic_vector(7 downto 0);

begin
  ce_5_sg_x10 <= ce_5;
  clk_5_sg_x10 <= clk_5;
  single_port_ram_data_out_net_x11 <= i;
  o <= single_port_ram_data_out_net_x12;

  constant3: entity work.constant3_bc1e67d7ac
    port map (
      ce => '0',
      clk => '0',
      clr => '0',
      op(0) => constant3_op_net
    );

  counter2: entity work.xlcounter_limit
    generic map (
      cnt_15_0 => 228,
      cnt_31_16 => 0,
      cnt_47_32 => 0,
      cnt_63_48 => 0,
      core_name0 => "binary_counter_virtex2p_7_0_ff2d32015ee9df2b",
      count_limited => 1,
      op_arith => xlUnsigned,
      op_width => 8
    )
    port map (
      ce => ce_5_sg_x10,
      clk => clk_5_sg_x10,
      clr => '0',
      en => "1",
      rst => "0",
      op => counter2_op_net
    );

  single_port_ram: entity work.xlspram
    generic map (
      c_address_width => 8,
      c_width => 8,
      core_name0 => "single_port_block_memory_virtex2p_6_1_9fca739df23a8df5",
      latency => 1
    )
    port map (
      addr => counter2_op_net,
      ce => ce_5_sg_x10,
      clk => clk_5_sg_x10,
      data_in => single_port_ram_data_out_net_x11,
      en => "1",
      rst => "0",
      we(0) => constant3_op_net,
      data_out => single_port_ram_data_out_net_x12
    );

end structural;
library IEEE;
use IEEE.std_logic_1164.all;
use work.conv_pkg.all;

-- Generated from Simulink block "edgePenh/Virtex2 5 Line Buffer"

entity virtex2_5_line_buffer_entity_88f7d32c3a is
  port (
    ce_5: in std_logic;
    clk_5: in std_logic;
    in1: in std_logic_vector(7 downto 0);
    line1: out std_logic_vector(7 downto 0);
    line2: out std_logic_vector(7 downto 0);
    line3: out std_logic_vector(7 downto 0);
    line4: out std_logic_vector(7 downto 0)
  );
end virtex2_5_line_buffer_entity_88f7d32c3a;

architecture structural of virtex2_5_line_buffer_entity_88f7d32c3a is
  signal ce_5_sg_x11: std_logic;
  signal clk_5_sg_x11: std_logic;
  signal register16_q_net_x3: std_logic_vector(7 downto 0);
  signal single_port_ram_data_out_net_x13: std_logic_vector(7 downto 0);
  signal single_port_ram_data_out_net_x14: std_logic_vector(7 downto 0);
  signal single_port_ram_data_out_net_x15: std_logic_vector(7 downto 0);
  signal single_port_ram_data_out_net_x8: std_logic_vector(7 downto 0);

begin
  ce_5_sg_x11 <= ce_5;
  clk_5_sg_x11 <= clk_5;
  register16_q_net_x3 <= in1;
  line1 <= single_port_ram_data_out_net_x15;
  line2 <= single_port_ram_data_out_net_x14;
  line3 <= single_port_ram_data_out_net_x13;
  line4 <= single_port_ram_data_out_net_x8;

  virtex2_line_buffer1_ba821f67ad: entity work.virtex2_line_buffer1_entity_ba821f67ad
    port map (
      ce_5 => ce_5_sg_x11,
      clk_5 => clk_5_sg_x11,
      i => single_port_ram_data_out_net_x8,
      o => single_port_ram_data_out_net_x13
    );

  virtex2_line_buffer2_5106f108fc: entity work.virtex2_line_buffer2_entity_5106f108fc
    port map (
      ce_5 => ce_5_sg_x11,
      clk_5 => clk_5_sg_x11,
      i => single_port_ram_data_out_net_x13,
      o => single_port_ram_data_out_net_x14
    );

  virtex2_line_buffer3_9c9da1e081: entity work.virtex2_line_buffer3_entity_9c9da1e081
    port map (
      ce_5 => ce_5_sg_x11,
      clk_5 => clk_5_sg_x11,
      i => single_port_ram_data_out_net_x14,
      o => single_port_ram_data_out_net_x15
    );

  virtex2_line_buffer_902f095c97: entity work.virtex2_line_buffer_entity_902f095c97
    port map (
      ce_5 => ce_5_sg_x11,
      clk_5 => clk_5_sg_x11,
      i => register16_q_net_x3,
      o => single_port_ram_data_out_net_x8
    );

end structural;
library IEEE;
use IEEE.std_logic_1164.all;
use work.conv_pkg.all;

-- Generated from Simulink block "edgePenh"

entity edgepenh is
  port (
    ce_1: in std_logic;
    ce_5: in std_logic;
    clk_1: in std_logic;
    clk_5: in std_logic;
    din: in std_logic_vector(7 downto 0);
    dout1: out std_logic_vector(18 downto 0)
  );
end edgepenh;

architecture structural of edgepenh is
  signal addsub_s_net: std_logic_vector(9 downto 0);
  signal ce_1_sg_x11: std_logic;
  signal ce_5_sg_x12: std_logic;
  signal clk_1_sg_x11: std_logic;
  signal clk_5_sg_x12: std_logic;
  signal cmult_p_net: std_logic_vector(17 downto 0);
  signal constant1_op_net: std_logic_vector(7 downto 0);
  signal constant_op_net: std_logic_vector(7 downto 0);
  signal convert1_dout_net_x0: std_logic_vector(7 downto 0);
  signal din_net: std_logic_vector(7 downto 0);
  signal dout1_net: std_logic_vector(18 downto 0);
  signal register16_q_net_x3: std_logic_vector(7 downto 0);
  signal register2_q_net: std_logic_vector(7 downto 0);
  signal single_port_ram_data_out_net_x13: std_logic_vector(7 downto 0);
  signal single_port_ram_data_out_net_x14: std_logic_vector(7 downto 0);
  signal single_port_ram_data_out_net_x15: std_logic_vector(7 downto 0);
  signal single_port_ram_data_out_net_x8: std_logic_vector(7 downto 0);

begin
  ce_1_sg_x11 <= ce_1;
  ce_5_sg_x12 <= ce_5;
  clk_1_sg_x11 <= clk_1;
  clk_5_sg_x12 <= clk_5;
  din_net <= din;
  dout1 <= dout1_net;

  addsub: entity work.xladdsub
    generic map (
      a_arith => xlUnsigned,
      a_bin_pt => 0,
      a_width => 8,
      b_arith => xlSigned,
      b_bin_pt => 0,
      b_width => 8,
      c_has_b_out => 0,
      c_has_c_out => 0,
      c_has_q => 0,
      c_has_q_b_out => 0,
      c_has_q_c_out => 0,
      c_has_s => 1,
      c_latency => 0,
      c_output_width => 10,
      core_name0 => "adder_subtracter_virtex2p_7_0_f4a3f2865eaa6412",
      extra_registers => 0,
      full_s_arith => 2,
      full_s_width => 10,
      latency => 0,
      mode => 2,
      overflow => 1,
      quantization => 1,
      s_arith => xlSigned,
      s_bin_pt => 0,
      s_width => 10
    )
    port map (
      a => register2_q_net,
      b => constant_op_net,
      ce => ce_5_sg_x12,
      clk => clk_5_sg_x12,
      clr => '0',
      en => "1",
      s => addsub_s_net
    );

  addsub1: entity work.xladdsub
    generic map (
      a_arith => xlSigned,
      a_bin_pt => 0,
      a_width => 18,
      b_arith => xlSigned,
      b_bin_pt => 0,
      b_width => 8,
      c_has_b_out => 0,
      c_has_c_out => 0,
      c_has_q => 0,
      c_has_q_b_out => 0,
      c_has_q_c_out => 0,
      c_has_s => 1,
      c_latency => 0,
      c_output_width => 19,
      core_name0 => "adder_subtracter_virtex2p_7_0_bb9ad611c94a03b2",
      extra_registers => 0,
      full_s_arith => 2,
      full_s_width => 19,
      latency => 0,
      mode => 1,
      overflow => 1,
      quantization => 1,
      s_arith => xlSigned,
      s_bin_pt => 0,
      s_width => 19
    )
    port map (
      a => cmult_p_net,
      b => constant1_op_net,
      ce => ce_5_sg_x12,
      clk => clk_5_sg_x12,
      clr => '0',
      en => "1",
      s => dout1_net
    );

  cmult: entity work.xlcmult
    generic map (
      a_arith => xlSigned,
      a_bin_pt => 0,
      a_width => 10,
      b_bin_pt => 0,
      c_a_type => 0,
      c_a_width => 10,
      c_b_type => 1,
      c_b_width => 8,
      c_output_width => 18,
      core_name0 => "multiplier_virtex2p_7_0_a1733d7085b607c4",
      extra_registers => 0,
      latency => 0,
      multsign => 2,
      overflow => 1,
      oversample => 1,
      p_arith => xlSigned,
      p_bin_pt => 0,
      p_width => 18,
      quantization => 1,
      zero_const => 0
    )
    port map (
      a => addsub_s_net,
      ce => ce_5_sg_x12,
      clk => clk_5_sg_x12,
      clr => '0',
      core_ce => ce_5_sg_x12,
      core_clk => clk_5_sg_x12,
      core_clr => '1',
      en => "1",
      rst => "0",
      p => cmult_p_net
    );

  constant1: entity work.constant1_e1a28c431e
    port map (
      ce => '0',
      clk => '0',
      clr => '0',
      op => constant1_op_net
    );

  constant_x0: entity work.constant_2dac288e77
    port map (
      ce => '0',
      clk => '0',
      clr => '0',
      op => constant_op_net
    );

  register16: entity work.xlregister
    generic map (
      d_width => 8,
      init_value => b"00000000"
    )
    port map (
      ce => ce_5_sg_x12,
      clk => clk_5_sg_x12,
      d => din_net,
      en => "1",
      rst => "0",
      q => register16_q_net_x3
    );

  register2: entity work.xlregister
    generic map (
      d_width => 8,
      init_value => b"00000000"
    )
    port map (
      ce => ce_5_sg_x12,
      clk => clk_5_sg_x12,
      d => convert1_dout_net_x0,
      en => "1",
      rst => "0",
      q => register2_q_net
    );

  virtex2_5_line_buffer_88f7d32c3a: entity work.virtex2_5_line_buffer_entity_88f7d32c3a
    port map (
      ce_5 => ce_5_sg_x12,
      clk_5 => clk_5_sg_x12,
      in1 => register16_q_net_x3,
      line1 => single_port_ram_data_out_net_x15,
      line2 => single_port_ram_data_out_net_x14,
      line3 => single_port_ram_data_out_net_x13,
      line4 => single_port_ram_data_out_net_x8
    );

  x5x5filter1_0b951638cd: entity work.x5x5filter1_entity_0b951638cd
    port map (
      ce_1 => ce_1_sg_x11,
      ce_5 => ce_5_sg_x12,
      clk_1 => clk_1_sg_x11,
      clk_5 => clk_5_sg_x12,
      line1 => single_port_ram_data_out_net_x15,
      line2 => single_port_ram_data_out_net_x14,
      line3 => single_port_ram_data_out_net_x13,
      line4 => single_port_ram_data_out_net_x8,
      line5 => register16_q_net_x3,
      out1 => convert1_dout_net_x0
    );

end structural;
